/*=========================================================================

						 >>> WonderGUI <<<

  This file is part of Tord Jansson's WonderGUI Graphics Toolkit
  and copyright (c) Tord Jansson, Sweden [tord.jansson@gmail.com].

							-----------

  The WonderGUI Graphics Toolkit is free software; you can redistribute
  this file and/or modify it under the terms of the GNU General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

							-----------

  The WonderGUI Graphics Toolkit is also available for use in commercial
  closed-source projects under a separate license. Interested parties
  should contact Tord Jansson [tord.jansson@gmail.com] for details.

=========================================================================*/
#ifndef	WG_UNIFORM_SIZEBROKER_DOT_H
#define	WG_UNIFORM_SIZEBROKER_DOT_H

#include <wg_sizebroker.h>

namespace wg
{


	class UniformSizeBroker;
	typedef	StrongPtr<UniformSizeBroker>		UniformSizeBroker_p;
	typedef	WeakPtr<UniformSizeBroker>	UniformSizeBroker_wp;

	class UniformSizeBroker : public SizeBroker
	{
	public:
		//.____ Creation __________________________________________

		static UniformSizeBroker_p	create() { return UniformSizeBroker_p(new UniformSizeBroker()); }

		//.____ Identification __________________________________________

		const TypeInfo&		typeInfo(void) const override;
		const static TypeInfo	TYPEINFO;

		//.____ Misc __________________________________________________

		MU setItemLengths( SizeBrokerItem * pItems, int nItems, MU totalLength ) const override;
		MU setPreferredLengths( SizeBrokerItem * pItems, int nItems ) const override;
		bool mayAlterPreferredLengths() const override;

	protected:
		UniformSizeBroker() {};
		virtual ~UniformSizeBroker() {};

		MU    _findLongestUnified( SizeBrokerItem * pItems, int nItems ) const;
	};




} // namespace wg
#endif //WG_UNIFORM_SIZEBROKER_DOT_H
